lib = {}

math.randomseed(os.time())

function lib.toTable(txt, match)
	local cmd = {}
	if not match then match = '[^%s]+' end
	for word in string.gmatch(txt, match) do
		table.insert(cmd, word)
	end
	return cmd
end

function lib.sound3(soundfile, x, y, playerid)
	local playerid = playerid or ''
	parse('sv_soundpos ' .. soundfile .. ' ' .. x .. ' ' .. y .. ' ' .. playerid)
end

function lib.sound(soundfile)
	parse('sv_sound ' .. soundfile)
end

function lib.tileTrigger(id)
	local x, y = player(id, 'x'), player(id, 'y')
	local rot = player(id, 'rot')
	local power = 32
	
	if rot < -90 then
		rot = rot + 360
	end
	
	local angle = math.rad(math.abs(rot + 90)) - math.pi
	local new_x = math.floor((x + math.cos(angle) * power) / 32)
	local new_y = math.floor((y + math.sin(angle) * power) / 32)
	
	return new_x, new_y
end

function lib.initArray(m, v)
	local array = {}
	for i = 1, m do
		if type(v) ~= 'table' then
			array[i] = v or nil
		else
			array[i] = {}
		end
	end
	return array
end

function lib.fileExists(path)
	local f = io.open(path, 'r')
	if f ~= nil then
		io.close(f)
		return true
	else
		return false
	end
end

function lib.getDayOfWeek(dd, mm, yy)
	local dw = os.date('*t', os.time{ year=yy, month=mm, day=dd })['wday'] - 1
	dw = dw == 0 and 7 or dw
	
	return {dw, ({'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun'})[dw]}
end

function lib.round(num, idp)
	local mult = 10 ^ (idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

local clock = os.clock
function lib.sleep(n) -- seconds
	local t0 = clock()
	while clock() - t0 <= n do end
end

--[[_player = player
function player(id, value)
	if value == 'name' then
		return _player(id, value):gsub('|','I')
	else
		return _player(id, value)
	end
end]]